/***********************************************************
 * $Id$
 *
 * FancyDrawing
 *
 * Copyright (C) 2009-2011 ev-i GmbH & IBCL e.U.
 * Copyright (C) 2011-2013 ITEG IT-Engineers GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#ifndef FANCYDRAWINGBARCODE39_H_
#define FANCYDRAWINGBARCODE39_H_

#include <fancydrawingbarcode.h>

namespace Fancy {

namespace Drawing {

class FANCYDRAWING_API Barcode39: virtual public Barcode {

public:
    typedef Fancy::ObjPtr<Barcode39> ptr_t;

    static ptr_t newInstance(bool _checksum, const std::string &s, double h =
            50.0, double lh = -1.0, double bw = -1.0, double ir = -1.0);

    std::string encoding() const;

    bool checkString(const std::string &s) const;
    void encode(const std::string &s);

private:
    void add_code(Bar *bars, int &i_bar, int code);
    bool do_checksum;

protected:
    Barcode39(bool _checksum);
    virtual ~Barcode39();
};

} /* namespace Drawing */
} /* namespace Fancy */

#endif /* FANCYDRAWINGBARCODE39_H_ */
